<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for deleteMaintenanceReason StructType
 * @subpackage Structs
 */
class DeleteMaintenanceReason extends AbstractStructBase
{
    /**
     * The reasons
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\MaintenanceReason[]
     */
    public $reasons;
    /**
     * The auth
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $auth;
    /**
     * Constructor method for deleteMaintenanceReason
     * @uses DeleteMaintenanceReason::setReasons()
     * @uses DeleteMaintenanceReason::setAuth()
     * @param \StructType\MaintenanceReason[] $reasons
     * @param \StructType\Credentials $auth
     */
    public function __construct(array $reasons = array(), \StructType\Credentials $auth = null)
    {
        $this
            ->setReasons($reasons)
            ->setAuth($auth);
    }
    /**
     * Get reasons value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\MaintenanceReason[]|null
     */
    public function getReasons()
    {
        return isset($this->reasons) ? $this->reasons : null;
    }
    /**
     * Set reasons value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\MaintenanceReason[] $reasons
     * @return \StructType\DeleteMaintenanceReason
     */
    public function setReasons(array $reasons = array())
    {
        foreach ($reasons as $deleteMaintenanceReasonReasonsItem) {
            // validation for constraint: itemType
            if (!$deleteMaintenanceReasonReasonsItem instanceof \StructType\MaintenanceReason) {
                throw new \InvalidArgumentException(sprintf('The reasons property can only contain items of \StructType\MaintenanceReason, "%s" given', is_object($deleteMaintenanceReasonReasonsItem) ? get_class($deleteMaintenanceReasonReasonsItem) : gettype($deleteMaintenanceReasonReasonsItem)), __LINE__);
            }
        }
        if (is_null($reasons) || (is_array($reasons) && empty($reasons))) {
            unset($this->reasons);
        } else {
            $this->reasons = $reasons;
        }
        return $this;
    }
    /**
     * Add item to reasons value
     * @throws \InvalidArgumentException
     * @param \StructType\MaintenanceReason $item
     * @return \StructType\DeleteMaintenanceReason
     */
    public function addToReasons(\StructType\MaintenanceReason $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\MaintenanceReason) {
            throw new \InvalidArgumentException(sprintf('The reasons property can only contain items of \StructType\MaintenanceReason, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->reasons[] = $item;
        return $this;
    }
    /**
     * Get auth value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getAuth()
    {
        return isset($this->auth) ? $this->auth : null;
    }
    /**
     * Set auth value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $auth
     * @return \StructType\DeleteMaintenanceReason
     */
    public function setAuth(\StructType\Credentials $auth = null)
    {
        if (is_null($auth) || (is_array($auth) && empty($auth))) {
            unset($this->auth);
        } else {
            $this->auth = $auth;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DeleteMaintenanceReason
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
